/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.infoproject;

import junit.framework.TestCase;

import org.gvsig.publish.util.LocalResourcesTestUtilities;

import com.iver.cit.gvsig.project.Project;

public class FilterProjectInfoTest extends TestCase {

	public void test_filter_layer_groups() throws Exception{
		LocalResourcesTestUtilities util = new LocalResourcesTestUtilities();
		//creates a gvSIG project and add several views
		Project gvProj = util.getProject();
		gvProj.addDocument(util.getView_group());
		//gvProj.addView(util.getView_group());
		//creates a project info
		ProjectInfo proj = new ProjectInfo(gvProj);
		FilterProjectInfo filter = new FilterProjectInfo();
		filter.setGroupedLayersEnabled(false);
		proj.setFilter(filter);		
		print(proj);
		//check
		IViewInfo[] views =	proj.getViewsInfo();
		for (int i =0; i<views.length;i++){
			ILayerInfo[] layers = views[i].getLayers();
			for (int j=0; j< layers.length; j++){
				this.assertNull(layers[j].getChilds());
			}
		}
	}

	private void print(ProjectInfo proj) {
		ProjectInfoTest.print(proj);		
	}
}
