/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.infoproject;

import junit.framework.TestCase;

import org.gvsig.publish.util.LocalResourcesTestUtilities;

import com.iver.cit.gvsig.project.documents.view.ProjectView;

public class LayerInfoTest extends TestCase {
	//gvSIG ProjectView
	private ProjectView gvView = null;
	//information about the view to publish
	private IViewInfo viewInfo = null;
	//get Resources from gvSIG like layers, views, ...
	private LocalResourcesTestUtilities util = null;
	
	protected void setUp() throws Exception {
		super.setUp();
		//gets a new view from the utilities
		util = new LocalResourcesTestUtilities();
		
		//creates a database 
		//util.createDBPostGIS();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		//util.dropDBPostGIS();
	}
	
	/**
	 * test simple shapes layers
	 */
	public void test_simpleLayer(){		
		gvView = util.getView_shape();
		viewInfo = new ViewInfo(gvView,null);
		for (int i = 0; i < this.viewInfo.getLayers().length; i++){			
			System.err.println("Layer " + i + " --------------");
			print(this.viewInfo.getLayers()[i]);					
		}		
	}
	/**
	 * test a grouped layer with shapes and raster
	 */
	public void test_groupedLayer(){
		gvView = util.getView_group();
		viewInfo = new ViewInfo(gvView,null);
		System.err.println("=====================================");
		for (int i = 0; i < this.viewInfo.getLayers().length; i++){
			System.err.println("Layer " + i + " --------------");
			print(this.viewInfo.getLayers()[i]);
		}		
	}
	/**
	 * TODO: print legend, datasourceinfo, ...
	 * @param l
	 */
	public static void print(ILayerInfo l){
		System.out.println("\t\t ------ TESTING LAYER INFO ---------");
		System.err.println("\t\tPath: " + l.getPathString());
		System.err.println("\t\tName: " + l.getName());
		System.err.println("\t\tTitle: " + l.getTitle());
		System.err.println("\t\tMaxScale: " + l.getMaxscale());
		System.err.println("\t\tMinScale: " + l.getMinscale());
		System.err.println("\t\tMaxX: " + l.getBBox().getMaxX());
		System.err.println("\t\tMaxY: " + l.getBBox().getMaxY());
		System.err.println("\t\tMinX: " + l.getBBox().getMinX());
		System.err.println("\t\tMinY: " + l.getBBox().getMinY());
		System.err.println("\t\tSRID: " + l.getSRID());
		if (l.getChilds() == null){
			System.err.println("\t\tGrouped?: falso");					
		}else{
			System.err.println("\t\tGrouped?: verdadero");
			ILayerInfo[] group = l.getChilds();
			for(int i= 0; i < group.length; i++ ){
				print(group[i]);
			}
		}
		
		
	}

}
