/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/**
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 */
package org.gvsig.publish.infoproject;

import junit.framework.TestCase;

import org.gvsig.publish.util.LocalResourcesTestUtilities;

import com.iver.cit.gvsig.project.Project;
/**
 * Test of ProjectInfImpl
 * 
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 *
 */
public class ProjectInfoTest extends TestCase {	
	/**
	 * test project with one view and shapes
	 * @throws Exception 
	 */
	public void test_one_view_shapes() throws Exception{
		LocalResourcesTestUtilities util = new LocalResourcesTestUtilities();
		//creates a gvSIG project and add several views
		Project gvProj = util.getProject();
		gvProj.addDocument(util.getView_shape());
		//creates a project info
		ProjectInfo proj = new ProjectInfo(gvProj);
		print(proj);
	}

	public static void print(IProjectInfo proj){
		System.out.println("------- TESTING PROJECT INFO -------------");
		System.out.println("getName():" + proj.getName());
		System.out.println("getOwner():" + proj.getOwner());
		IViewInfo[] views = proj.getViewsInfo();
		for (int i =0; i < views.length; i++){
			ViewInfoTest.print(views[i]);
		}
	}
}
