/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

package org.gvsig.publish.infoproject;


import junit.framework.TestCase;

import org.gvsig.publish.util.LocalResourcesTestUtilities;

import com.iver.cit.gvsig.project.documents.view.ProjectView;


/**
 * We are testing all methods of DefaultView.  
 * 
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 *
 */
public class ViewInfoTest extends TestCase {

	LocalResourcesTestUtilities util = null;
	
	/**
	 * initializes the test
	 */
	protected void setUp() throws Exception {
		//File f = null;
		super.setUp();
		//gets a new view from the utilities
		 util = new LocalResourcesTestUtilities();
		//creates a database 
		//util.createDBPostGIS();
	}
	/**
	 * after the test
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}
	/**
	 * test view with shapes
	 */
	public void test_view_shapes(){
		ProjectView gvView = util.getView_shape();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);			
	}
	/**
	 * test view with raster
	 */
	public void test_view_raster(){
		ProjectView gvView = util.getView_raster();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with group
	 */
	public void test_view_group(){
		ProjectView gvView = util.getView_group();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with intervals
	 */
	public void test_view_intervals(){
		ProjectView gvView = util.getView_intervals();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with labeling
	 */
	public void test_view_label(){
		ProjectView gvView = util.getView_label();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with lines
	 */
	public void test_view_line(){
		ProjectView gvView = util.getView_line();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with point
	 */
	public void test_view_point(){
		ProjectView gvView = util.getView_point();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with polygon
	 */
	public void test_view_polygon(){
		ProjectView gvView = util.getView_polygon();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with postgis datasources
	 */
	public void test_view_postgis(){
		ProjectView gvView = util.getView_postgis();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with different srs
	 */
	public void test_view_srs(){
		ProjectView gvView = util.getView_srs();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * test view with unique values
	 */
	public void test_view_uniquevalues(){
		ProjectView gvView = util.getView_unique_values();
		IViewInfo viewInfo = new ViewInfo(gvView,null);
		print(viewInfo);	
	}
	/**
	 * Print ViewInfo properties 
	 * @param viewInfo
	 */
	public static void print(IViewInfo viewInfo){
		System.out.println("\t -----TESTING VIEW INFO -----------");
		System.out.println("\t getName():" + viewInfo.getName());
		System.out.println("\t getOwner():" + viewInfo.getOwner());
		System.out.println("\t getComment():" + viewInfo.getComment());
		System.out.println("\t getCreationDate():"+viewInfo.getCreationDate());
		System.out.println("\t getEPSG():" + viewInfo.getEPSG());
		System.out.println("\t getBBOX():" + viewInfo.getBBox().getMinX() + ","+viewInfo.getBBox().getMinY() + "," +viewInfo.getBBox().getMaxX() + "," +viewInfo.getBBox().getMaxY() );
		ILayerInfo[] layers = viewInfo.getLayers();		
		for (int i = 0 ; i < layers.length; i++){
			LayerInfoTest.print(layers[i]);
			
		}
	}

}
