/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.ogcmetadata;

import junit.framework.TestCase;

import org.gvsig.publish.IPublishPersistence;

import com.iver.utiles.XMLEntity;

public class OGCCommonMetadataTest extends TestCase {
	
	public void test_persistence(){
		IOGCCommonMetadata imetadata = new OGCCommonMetadata();
		IPublishPersistence ipersist = (IPublishPersistence)imetadata;
		//test basic operations
		imetadata.setName("name");
		assertEquals("name", imetadata.getName());
		imetadata.setTitle("title");
		assertEquals("title", imetadata.getTitle());
		imetadata.setAbstract("abstract");		
		assertEquals("abstract", imetadata.getAbstract());
		//test persist operations
		XMLEntity entity = ipersist.getXMLEntity();
		assertEquals(ipersist.getClassName(), entity.getName());
		assertEquals(ipersist.getVersion(), entity.getIntProperty("version"));
		assertEquals("name", entity.getStringProperty("ogcname"));
		assertEquals("title", entity.getStringProperty("ogctitle"));
		assertEquals("abstract", entity.getStringProperty("ogcabstract"));
		System.err.println(entity.toString());
		ipersist.setXMLEntity(entity);
		assertEquals("name", imetadata.getName());
		assertEquals("title", imetadata.getTitle());
		assertEquals("abstract", imetadata.getAbstract());
	}

}
