/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish;

import java.text.DateFormat;
import java.util.Date;
import java.util.Hashtable;

import javax.swing.ImageIcon;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.project.Project;
import com.iver.cit.gvsig.project.documents.ProjectDocument;
import com.iver.cit.gvsig.project.documents.ProjectDocumentFactory;
import com.iver.utiles.XMLEntity;

public class PublicationFactory extends ProjectDocumentFactory {
	/**
	 * @return a string which identifies the type of document
	 */
	public String getNameType() {		
		return PluginServices.getText(this, "publish_publication");
	}

	public static String registerName="publication";
    private int numDocument = 0;
	public static void register(){
		   register(registerName, new PublicationFactory());
	}
	public ProjectDocument create(Project project) {
		//get information about the project
		//IProjectInfo prjInfo = ProjectInfoFactory.getProjectInfo(project);
		ProjectPublication m = new ProjectPublication();
	        m.setName(PluginServices.getText(this, "publish_publication") + " - " +
	            numDocument);
	        m.setCreationDate(DateFormat.getInstance().format(new Date()));
	        numDocument++;
//	        m.setProject(project, 0);
	        return m;
	}

	public ImageIcon getButtonIcon() {
		return new ImageIcon(ProjectPublication.class.getClassLoader().getResource("images/publish-publication.png"));
	}

	public String getRegisterName() {		
		return registerName;
	}

	public ImageIcon getSelectedButtonIcon() {
		return new ImageIcon(ProjectPublication.class.getClassLoader().getResource("images/publish-publication_sel.png"));
	}

	public boolean resolveImportXMLConflicts(XMLEntity root, Project project,
			Hashtable conflicts) {
		// TODO Auto-generated method stub
		return false;
	}

}
