/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/**
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 */
package org.gvsig.publish;

import org.gvsig.publish.gui.publish.PublishWindow;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.About;
import com.iver.cit.gvsig.gui.panels.FPanelAbout;

public class PublishExtension extends Extension {
	/**
	 * 
	 * To get the "add resource controller" in order to show the window "addResourceWindow",
	 * I need to know the active publication:
	 * I must get the active window (PublishWindow) and get the controller
	 *  
	 */
	public void execute(String actionCommand) {		
//		if (actionCommand.compareTo("ADD_RESOURCE")==0){
//
//			//gets all the "ProjectPublish"		
//			ProjectExtension projectExtension = (ProjectExtension) PluginServices.getExtension(ProjectExtension.class);
//			Project project = projectExtension.getProject();
//			ArrayList allPrjPub = project.getDocumentsByType(PublicationFactory.registerName);
//
//			//gets the active window
//			PublishWindow activeWindow = (PublishWindow) PluginServices.getMDIManager().getActiveWindow();
//			Publication active = activeWindow.getActivePublication();
//
//			//gets the pubication document active
//			Iterator i = allPrjPub.iterator();
//			while (i.hasNext()){
//				ProjectPublication prjPub = (ProjectPublication) i.next();
//				if (prjPub.getPublication().equals(active)){
//					prjPub.getAddResourceController().showWindow();
//				}
//			}
//
//		}         		
	}
	/**
	 * Registers the publication factory 
	 */
	public void initialize() {
		PublicationFactory.register();
	}
	/**
	 * Returns if the extension is enabled
	 */
	public boolean isEnabled() {
		return true;
	}
	/**
	 * Only is visible when a publication is selected
	 */
	public boolean isVisible() {
		IWindow f = PluginServices.getMDIManager().getActiveWindow();
		if (f == null) {
			return false;
		}
		boolean isPublication = f instanceof PublishWindow; 
		return (isPublication);	
	}
	/**
	 * Initializes the "about" panel
	 */
	public void postInitialize() {
		super.postInitialize();
		About about=(About)PluginServices.getExtension(About.class);
		FPanelAbout panelAbout=about.getAboutPanel();
		java.net.URL aboutURL = this.getClass().getResource("/about.htm");
		panelAbout.addAboutUrl(PluginServices.getText(this,"Publish"),aboutURL);
	 
	}

}
