/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.addResource;

import java.awt.event.ActionListener;
import java.util.EventListener;

import javax.swing.JPanel;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreeSelectionModel;

import org.gvsig.gui.beans.swing.JButton;
import org.gvsig.publish.PublishLogger;
import org.gvsig.publish.infoproject.IProjectInfo;

import com.iver.andami.PluginServices;


public class AddResourcePanel extends JPanel {
	
	public AddResourcePanel(){
		super();
		initComponents();
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
		initLabels();		
	}
	private void initLabels(){		
		treePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this, "publish_resources")));
		addButton.setText(PluginServices.getText(this,"publish_add"));
        cancelButton.setText(PluginServices.getText(this, "publish_cancel"));
	}
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        treePanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tree = new javax.swing.JTree();
        buttonsPanel = new javax.swing.JPanel();
        addButton = new JButton();
        cancelButton = new JButton();

        setLayout(new java.awt.BorderLayout());

        treePanel.setLayout(new java.awt.GridBagLayout());

        
        jScrollPane1.setViewportView(tree);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        treePanel.add(jScrollPane1, gridBagConstraints);

        add(treePanel, java.awt.BorderLayout.CENTER);

        buttonsPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        
        buttonsPanel.add(addButton);

        buttonsPanel.add(cancelButton);

        add(buttonsPanel, java.awt.BorderLayout.SOUTH);

    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    private JButton addButton;
    private javax.swing.JPanel buttonsPanel;
    private JButton cancelButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree tree;
    private javax.swing.JPanel treePanel;
    // End of variables declaration
	  	
	public void setListener(EventListener listener) {
		//Sets tree listener
		tree.addTreeSelectionListener((TreeSelectionListener) listener);
		//Sets buttons listener		
		addButton.addActionListener((ActionListener)listener);
		addButton.setActionCommand(AddResourceController.ADDRESOURCE_EVENT_ACCEPT);
		cancelButton.addActionListener((ActionListener)listener);
		cancelButton.setActionCommand(AddResourceController.ADDRESOURCE_EVENT_CANCEL);		
	}
	 
		
	public void setModel(IProjectInfo project){
		if (project == null){
			PublishLogger.getLog().error("ERROR AddResourcePanel: the project can't be null");		
		}else{		
			tree.setModel(new ProjectInfoTreeModel(project));
		}
	}
}
