/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.addResource;


import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import org.gvsig.publish.PublishLogger;
import org.gvsig.publish.infoproject.ILayerInfo;
import org.gvsig.publish.infoproject.IProjectInfo;
import org.gvsig.publish.infoproject.IViewInfo;

/**
 * Class to represent the information about the project with a tree
 * 
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 *
 */
public class ProjectInfoTreeModel implements TreeModel {
	IProjectInfo project = null;
	
	public ProjectInfoTreeModel(IProjectInfo p){
		project = p;
	}
	
	public void addTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub

	}
	/**
	 * Gets the childs count, if the parent is a projectinfo, at
	 * the moment, it only has a child (viewinfo) 
	 */
	public int getChildCount(Object parent) {
		if(parent instanceof IProjectInfo){
			IProjectInfo project = (IProjectInfo)parent;
			return project.getViewsInfo().length;
		}
		if (parent instanceof IViewInfo){
			IViewInfo view = (IViewInfo) parent;
			if (view.getLayers() == null){
				return 0;
			}else{
				return view.getLayers().length;
			}			
		}
		if (parent instanceof ILayerInfo){
			ILayerInfo layer =(ILayerInfo) parent;
			if (layer.getChilds() == null){
				return 0;
			}else{
				return layer.getChilds().length;
			}
		}
		return 0;
	}

	public int getIndexOfChild(Object parent, Object child) {
		// TODO Auto-generated method stub
		return 0;
	}

	public Object getRoot() {
		return project;		
	}

	public boolean isLeaf(Object node) {
		if (node instanceof ILayerInfo){
			ILayerInfo layer = (ILayerInfo)node;
			if(layer.getChilds() == null){
				return true;		
			}
		}
		return false;
	}

	public void removeTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub

	}

	public void valueForPathChanged(TreePath path, Object newValue) {
		// TODO Auto-generated method stub

	}
	/**
	 * Get the child of a projectinfo, viewinfo or layerinfo
	 */
	public Object getChild(Object parent, int index) {
		if (parent instanceof IProjectInfo){
			IProjectInfo p = (IProjectInfo)parent;
			return p.getViewsInfo()[index];
		}
		if (parent instanceof IViewInfo){
			IViewInfo v = (IViewInfo)parent;
			return v.getLayers()[index];
		}
		if (parent instanceof ILayerInfo){
			ILayerInfo l = (ILayerInfo)parent;
			return l.getChilds()[index];
		}
		PublishLogger.getLog().error("ERROR ProjectInfoTreeModel: I'm going to return a null!!");
		return null;
	}

}
