/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.browser;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import org.gvsig.publish.PublishLogger;
import org.gvsig.publish.serversmodel.Publication;
import org.gvsig.publish.serversmodel.RemoteResource;
import org.gvsig.publish.serversmodel.Server;
import org.gvsig.publish.serversmodel.Service;


public class ServersTreeModel implements TreeModel {
	Publication publication = null;
	
	public ServersTreeModel(Publication p){
		publication = p;
	}
	
	public void addTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub

	}

	public int getChildCount(Object parent) {
		if (parent instanceof Server){
			Server server = (Server) parent;
			return server.getServicesCount();
		}
		if (parent instanceof Service){
			Service service = (Service) parent;
			return service.getRemoteResourcesCount();
		}
		if (parent instanceof RemoteResource){
			RemoteResource remoteResource = (RemoteResource)parent;
			return remoteResource.getChildsCount();
		}
		return 0;
	}

	public int getIndexOfChild(Object parent, Object child) {
		// TODO Auto-generated method stub
		return 0;
	}

	public Object getRoot() {
		return publication.getServer();		
	}

	public boolean isLeaf(Object node) {		
		if (node instanceof Server){
			Server s = (Server)node;
			if (s.getServicesCount() == 0){
				return true;
			}
		}
		if (node instanceof Service){
			Service s = (Service)node;
			if (s.getRemoteResourcesCount() == 0){
				return true;
			}
		}
		if (node instanceof RemoteResource){
			RemoteResource r = (RemoteResource)node;
			if (r.getChildsCount() == 0){
				return true;
			}
		}
		return false;
	}

	public void removeTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub

	}

	public void valueForPathChanged(TreePath path, Object newValue) {
		// TODO Auto-generated method stub

	}
	/**
	 * TODO: I think we can improve the performance, each time you
	 * want a child you are getting all the Collection
	 */
	public Object getChild(Object parent, int index) {
		if (parent instanceof Server){
			Server server = (Server) parent;
			return server.getService(index);
		}
		if (parent instanceof Service){
			Service service = (Service) parent;
			return service.getRemoteResource(index);
		}
		if (parent instanceof RemoteResource){
			RemoteResource remoteResource = (RemoteResource) parent;
			return remoteResource.getChild(index);
		}
		PublishLogger.getLog().error("ERROR ServersTreeModel: I'm going to return a null!!");
		return null;
	}

}
