/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.common;

import java.io.File;

import javax.swing.JFileChooser;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.utiles.GenericFileFilter;
/**
 * FileChooser to use in the publish framework. You can define a filter as well.
 * 
 * 
 * @author jvhigon
 *
 */
public class PublishFileChooser extends JFileChooser implements IWindow {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1932522749703561777L;
	WindowInfo mWindowInfo = null;
	/*
	 * Dependences
	 */
	private GenericFileFilter filter = null;
	/**
	 * default constructor
	 */
	public PublishFileChooser() {
		super();
	}
	/**
	 * Constructor
	 * @param initialDirectory
	 */
	public PublishFileChooser(File initialDirectory){
		super(initialDirectory);		
	}
	/*
	 * (non-Javadoc)
	 * @see com.iver.andami.ui.mdiManager.IWindow#getWindowInfo()
	 */
	public WindowInfo getWindowInfo() {
		if (mWindowInfo == null){
			//mWindowInfo=new WindowInfo(WindowInfo.MODALDIALOG | WindowInfo.RESIZABLE);
			mWindowInfo=new WindowInfo(WindowInfo.MODELESSDIALOG | WindowInfo.RESIZABLE);
			mWindowInfo.setTitle(PluginServices.getText(this,"mapfile_chooser_window"));
			mWindowInfo.setHeight(100);
			mWindowInfo.setWidth(200);
		}
		return mWindowInfo;
	}
	/**
	 * @return the filter
	 */
	public GenericFileFilter getFilter() {
		return filter;
	}
	/**
	 * Sets a filter in order to select only the files with a particular extension.
	 * For example:
	 * <br>
	 *  	String format = "map";
	 * <br>
	 *		String description = "Mapserver mapfiles";
	 * <br>
	 *		filter = new GenericFileFilter(format, description);
	 * <br>
	 *		setFileFilter(filter);
	 * @param filter to set
	 */
	public void setFilter(GenericFileFilter filter) {
		this.filter = filter;
	}

}
