/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.ogcMetadata;

import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.publish.gui.publish.IPublishPluginPanel;
import org.gvsig.publish.ogcmetadata.IOGCCommonMetadata;

import com.iver.andami.PluginServices;

/**
 * Panel for common properties of ogc entities  
 * 
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 *
 */
public class OGCCommonMetadataPanel extends JPanel implements IPublishPluginPanel{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5635866784035391505L;
	/*
	 * model
	 */
	private IOGCCommonMetadata model_ogcmetadata = null;
	
	/**
	 * Constructor
	 */
	public OGCCommonMetadataPanel(){
		super();
		initComponents();
		initLabels();
	}
	private void initLabels(){
		setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this,"publish_common_ogc_properties")));
		nameLabel.setText(PluginServices.getText(this,"publish_name"));
        //nameField.setText(PluginServices.getText(this, "name"));
        titleLabel.setText(PluginServices.getText(this,"publish_title"));
        //titleField.setText(PluginServices.getText(this,"title"));
        abstractLabel.setText(PluginServices.getText(this,"publish_abstract"));
	}
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        nameLabel = new javax.swing.JLabel();
        nameField = new javax.swing.JTextField();
        titleLabel = new javax.swing.JLabel();
        titleField = new javax.swing.JTextField();
        abstractLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        abstractArea = new javax.swing.JEditorPane();

        setBorder(javax.swing.BorderFactory.createTitledBorder("common_ogc"));
        setAutoscrolls(true);
        setMaximumSize(new java.awt.Dimension(10, 10));
        setPreferredSize(new java.awt.Dimension(300, 150));
        setLayout(new java.awt.GridBagLayout());

        nameLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        nameLabel.setText("name_label");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(nameLabel, gridBagConstraints);

        nameField.setColumns(30);
        nameField.setEditable(false);
        nameField.setText("name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(nameField, gridBagConstraints);

        titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        titleLabel.setText("title_label");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(titleLabel, gridBagConstraints);

        titleField.setColumns(30);
        titleField.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        titleField.setText("titlee");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(titleField, gridBagConstraints);

        abstractLabel.setText("abstract_label");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(abstractLabel, gridBagConstraints);

        jScrollPane1.setViewportView(abstractArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(jScrollPane1, gridBagConstraints);
    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    public javax.swing.JEditorPane abstractArea;
    private javax.swing.JLabel abstractLabel;
    private javax.swing.JScrollPane jScrollPane1;
    public javax.swing.JTextField nameField;
    private javax.swing.JLabel nameLabel;
    public javax.swing.JTextField titleField;
    private javax.swing.JLabel titleLabel;
    // End of variables declaration
  
   	public Object getModel() {
		model_ogcmetadata.setName(nameField.getText());
		model_ogcmetadata.setTitle(titleField.getText());
		model_ogcmetadata.setAbstract(abstractArea.getText());
		return model_ogcmetadata;
	}

	public void setListener(EventListener listener) {
		// TODO Auto-generated method stub
		
	}

	public void setModel(Object entityModel) {
		// Cast to CommonOGCMetadat
		model_ogcmetadata = (IOGCCommonMetadata)entityModel;
		nameField.setText(model_ogcmetadata.getName());
		titleField.setText(model_ogcmetadata.getTitle());
		abstractArea.setText(model_ogcmetadata.getAbstract());
	}

}
