/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.ogcMetadata;

import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.publish.gui.publish.IPublishPluginPanel;
import org.gvsig.publish.ogcmetadata.IOGCLayerMetadata;

import com.iver.andami.PluginServices;

public class OGCLayerMetadataPanel extends JPanel implements IPublishPluginPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7415209435536089676L;
	/*
	 * model
	 */
	private IOGCLayerMetadata model_layerwms = null; 
	
	public OGCLayerMetadataPanel() {
		initComponents();
		initLabels();
	}
	private void initLabels(){
		setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this,"publish_layer_wms111")));
		isQueryableCheck.setText(PluginServices.getText(this,"publish_is_queryable"));
	}
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        isQueryableCheck = new javax.swing.JCheckBox();

        setBorder(javax.swing.BorderFactory.createTitledBorder("Layer WMS 1.1.1"));
        setLayout(new java.awt.GridBagLayout());

        isQueryableCheck.setText("is queryable");
        isQueryableCheck.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        isQueryableCheck.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        isQueryableCheck.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        isQueryableCheck.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        add(isQueryableCheck, gridBagConstraints);
    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    private javax.swing.JCheckBox isQueryableCheck;
    // End of variables declaration
	
	public Object getModel() {
		model_layerwms.setQueryable(isQueryableCheck.isSelected());
		return model_layerwms;
	}

	public void setListener(EventListener listener) {
		// TODO Auto-generated method stub

	}

	public void setModel(Object entityModel) {
		//Cast to LayerWMS111Metadata
		model_layerwms = (IOGCLayerMetadata)entityModel;
		isQueryableCheck.setSelected(model_layerwms.isQueryable());
	}

}
