/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.ogcMetadata;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.EventListener;

import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.gvsig.publish.gui.publish.IPublishPluginPanel;
import org.gvsig.publish.ogcmetadata.IOGCServiceMetadata;

import com.iver.andami.PluginServices;

public class OGCServiceMetadataPanel extends JPanel implements IPublishPluginPanel {
		/**
	 * 
	 */
	private static final long serialVersionUID = -5653327425351006165L;
		/*
		 * model
		 */
		private IOGCServiceMetadata model_servicewms = null;
		
		/**
		 * Constructor
		 */
	    public OGCServiceMetadataPanel() {
	        initComponents();
	        initLabels();
	    }
	    private void initLabels(){
	    	setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this,"publish_service_properties")));
	    	onlineresourceLabel.setText(PluginServices.getText(this,"publish_online_resource"));
	    }
	    private void initComponents() {
	        java.awt.GridBagConstraints gridBagConstraints;

	        onlineresourceLabel = new javax.swing.JLabel();
	        onlinreresourceField = new javax.swing.JTextField();

	        setBorder(javax.swing.BorderFactory.createTitledBorder("service_ogc"));
	        setLayout(new java.awt.GridBagLayout());

	        onlineresourceLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
	        onlineresourceLabel.setText("online resource");
	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
	        add(onlineresourceLabel, gridBagConstraints);

	        onlinreresourceField.setText("http://");
	        gridBagConstraints = new java.awt.GridBagConstraints();
	        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
	        gridBagConstraints.weightx = 1.0;
	        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
	        add(onlinreresourceField, gridBagConstraints);
	    }// </editor-fold>
	    
	    
	    // Variables declaration - do not modify
	    private javax.swing.JLabel onlineresourceLabel;
	    private javax.swing.JTextField onlinreresourceField;
	    // End of variables declaration
	    
	public Object getModel() {
		if (onlinreresourceField.getText().equals("")){
			model_servicewms.setOnlineResource(null);
		}else{
			URL url=null;
			try {
				url = new URL(onlinreresourceField.getText());
			} catch (MalformedURLException e) {
				JOptionPane.showMessageDialog(this,"malformed_url","ServiceWMS111Panel",JOptionPane.ERROR_MESSAGE);
			}
			model_servicewms.setOnlineResource(url);
		}
		
		return model_servicewms;
	}

	public void setListener(EventListener listener) {
		// TODO Auto-generated method stub

	}

	public void setModel(Object entityModel) {
		//cast to ServiceWMS111Metadata
		model_servicewms = (IOGCServiceMetadata)entityModel;
		if (model_servicewms.getOnlineResource() != null){
			onlinreresourceField.setText(model_servicewms.getOnlineResource().toString());
		}
	}

}
