/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.ogcMetadata;

import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.publish.PublishLogger;
import org.gvsig.publish.gui.publish.IPublishPluginPanel;
import org.gvsig.publish.ogcmetadata.IOGCServiceMetadata;
/**
 * Panel for any WFS service
 * @author jvhigon
 *
 */
public class OGCWFSPanel extends JPanel implements IPublishPluginPanel {
	//model
	private IOGCServiceMetadata model;
	/**
	 * constructor
	 */
	public OGCWFSPanel() {
		super();
		initComponents();
		initLabels();
		initIcons();
	}
	
	private void initIcons() {
		//wms logo
		try {
			icon.setIcon(new javax.swing.ImageIcon(getClass().getClassLoader().getResource("images/publish-wfs10.gif")));			
		}catch( java.lang.NullPointerException e){
			PublishLogger.getLog().error("ERROR " + getClass().getName() + ":Error loading icons", e);
		}				
	}

	private void initLabels() {
		// TODO Auto-generated method stub
		
	}

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        icon = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        commonPanel = new org.gvsig.publish.gui.ogcMetadata.OGCCommonMetadataPanel();
        servicePanel = new org.gvsig.publish.gui.ogcMetadata.OGCServiceMetadataPanel();

        setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(icon, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(jSeparator1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(commonPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(servicePanel, gridBagConstraints);
    }// </editor-fold>
    
    
    // Variables declaration - do not modify
    private org.gvsig.publish.gui.ogcMetadata.OGCCommonMetadataPanel commonPanel;
    private javax.swing.JLabel icon;
    private javax.swing.JSeparator jSeparator1;
    private org.gvsig.publish.gui.ogcMetadata.OGCServiceMetadataPanel servicePanel;
    // End of variables declaration
    
	public Object getModel() {
		commonPanel.getModel();
		servicePanel.getModel();
		return model;
	}

	public void setListener(EventListener listener) {		
		commonPanel.setListener(listener);
		servicePanel.setListener(listener);
	}

	public void setModel(Object entityModel) {
		//cast 
		model = (IOGCServiceMetadata)entityModel;
		commonPanel.setModel(model);
		servicePanel.setModel(model);
	}

}
