/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.properties;

import javax.swing.JPanel;

import org.gvsig.publish.PublishExtension;
import org.gvsig.publish.PublishLogger;

import com.iver.andami.PluginServices;
/**
 * Publication properties panel 
 * 
 * @author jvhigon
 *
 */
public class PublicationPropertiesPanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3296726720644694610L;
	/**
	 * Constructor
	 */
	public PublicationPropertiesPanel() {
		initComponents();
		remoteMPPanel.setVisible(false);
		initLabels();
		initIcons();
	}
	/**
	 * Initialize components with the resources form the classpath
	 */
    private void initIcons() {
    	try {
			fileButton.setIcon(new javax.swing.ImageIcon(PublishExtension.class.getClassLoader().getResource("images/publish-fileopen.gif")));			
		}catch( java.lang.NullPointerException e){
			PublishLogger.getLog().error("ERROR " + getClass().getName() + ":Error loading icons", e);
		}		
	}
    /**
     * Initialize label components for multi-language
     */
	private void initLabels() {
		remoteMPPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this, "publish_remote_filesystem")));
        propertiesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this,"publish_file_access")));		
		localpointLabel.setText(PluginServices.getText(this,"publish_local_mount_point"));
		remotePointLabel.setText(PluginServices.getText(this,"publish_remote_mount_point"));
		fileaccessCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { PluginServices.getText(this,"publish_access_local"),PluginServices.getText(this, "publish_access_remote_mount_point") }));
		acceptButton.setText(PluginServices.getText(this,"publish_accept"));
		cancelButton.setText(PluginServices.getText(this,"publish_cancel"));
	}
	/**
	 * Initializes java GUI components
	 */
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        propertiesPanel = new javax.swing.JPanel();
        remoteMPPanel = new javax.swing.JPanel();
        localpointLabel = new javax.swing.JLabel();
        remotePointLabel = new javax.swing.JLabel();
        localmpText = new javax.swing.JTextField();
        remotempText = new javax.swing.JTextField();
        fileButton = new org.gvsig.gui.beans.swing.JButton();
        fileaccessCombo = new javax.swing.JComboBox();
        buttonsPanel = new javax.swing.JPanel();
        acceptButton = new org.gvsig.gui.beans.swing.JButton();
        cancelButton = new org.gvsig.gui.beans.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        propertiesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("file_access"));
        propertiesPanel.setLayout(new java.awt.GridBagLayout());

        remoteMPPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("remote_filesystem"));
        remoteMPPanel.setLayout(new java.awt.GridBagLayout());

        localpointLabel.setText("local_mount_point");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        remoteMPPanel.add(localpointLabel, gridBagConstraints);

        remotePointLabel.setText("remote_mount_point");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        remoteMPPanel.add(remotePointLabel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        remoteMPPanel.add(localmpText, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        remoteMPPanel.add(remotempText, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        remoteMPPanel.add(fileButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        propertiesPanel.add(remoteMPPanel, gridBagConstraints);

        fileaccessCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "access_local", "access_remote_mount_point" }));
        fileaccessCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileaccessComboActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        propertiesPanel.add(fileaccessCombo, gridBagConstraints);

        add(propertiesPanel, java.awt.BorderLayout.NORTH);

        acceptButton.setText("accept");
        buttonsPanel.add(acceptButton);

        cancelButton.setText("cancel");
        buttonsPanel.add(cancelButton);

        add(buttonsPanel, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>

    private void fileaccessComboActionPerformed(java.awt.event.ActionEvent evt) {
        if (fileaccessCombo.getSelectedIndex() == 0){
            remoteMPPanel.setVisible(false);
        }else{
            remoteMPPanel.setVisible(true);
        }
    }
    
    
    // Variables declaration - do not modify
    public org.gvsig.gui.beans.swing.JButton acceptButton;
    private javax.swing.JPanel buttonsPanel;
    public org.gvsig.gui.beans.swing.JButton cancelButton;
    public org.gvsig.gui.beans.swing.JButton fileButton;
    public javax.swing.JComboBox fileaccessCombo;
    public javax.swing.JTextField localmpText;
    private javax.swing.JLabel localpointLabel;
    private javax.swing.JPanel propertiesPanel;
    public javax.swing.JPanel remoteMPPanel;
    private javax.swing.JLabel remotePointLabel;
    public javax.swing.JTextField remotempText;
    // End of variables declaration

}
