/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.publish;

import java.awt.event.ActionListener;
import java.util.EventListener;

import javax.swing.JPanel;

import org.gvsig.gui.beans.swing.JButton;
import org.gvsig.publish.serversmodel.Publication;

import com.iver.andami.PluginServices;

/**
 * Main panel for publishing. It contains the publication panel and buttons. 
 * 
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 *
 */
public class PublishPanel extends JPanel {
//	private PublishControlsPanel controlsPanel;
//	private JPanel publicationPanel;
			
	/**
	 * Constructor
	 */
	public PublishPanel(){
		super();		
		initComponents();
		initLabels();
	}
	private void initLabels(){
		acceptButton.setText(PluginServices.getText(this,"publish_publish"));
		cancelButton.setText(PluginServices.getText(this,"publish_cancel"));
	}
	/**
	 * Testing with netbeans
	 * 
	 */
	// Variables declaration - do not modify
    private JButton acceptButton;
    private JPanel buttonsPanel;
    private JButton cancelButton;
    private JPanel publicationPanel;
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">                          
    private void initComponents() {
        buttonsPanel = new JPanel();
        acceptButton = new JButton();
        cancelButton = new JButton();
        publicationPanel = new JPanel();

        setLayout(new java.awt.BorderLayout());

        buttonsPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        
        buttonsPanel.add(acceptButton);

        
        buttonsPanel.add(cancelButton);

        add(buttonsPanel, java.awt.BorderLayout.SOUTH);

        publicationPanel.setLayout(new java.awt.GridBagLayout());

        add(publicationPanel, java.awt.BorderLayout.CENTER);

    }// </editor-fold>                        
    
	
	public void setPublicationPanel(JPanel p){
		if (publicationPanel != null){
			remove(publicationPanel);
		}
		publicationPanel = p;
		this.add(getPublicationPanel(), java.awt.BorderLayout.CENTER);
	}
	public void setListener(EventListener listener) {
		//controlsPanel.setListener(listener);
		
		//Testing NetBeans
		this.acceptButton.addActionListener((ActionListener)listener);
		this.cancelButton.addActionListener((ActionListener)listener);
		this.cancelButton.setActionCommand(PublishController.PUBLISH_EVENT_CANCEL);
		this.acceptButton.setActionCommand(PublishController.PUBLISH_EVENT_ACCEPT);
	}
	private JPanel getPublicationPanel(){
		return publicationPanel;
	}
	/**
	 * I need this method in order to know the active publication when
	 * the user adds a resource (the event is process in the PublishExtension)
	 * @return
	 */
	public Publication getActivePublication(){
		IPublishPluginPanel pluginPanel = (IPublishPluginPanel) getPublicationPanel();
		Publication p = (Publication) pluginPanel.getModel();
		return p;
	}
}
