/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.remove;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashSet;

import javax.swing.JButton;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;

import org.gvsig.publish.serversmodel.RemoteResource;

/**
 * Control for removing a remote resources from the publication 
 * 
 * @author jvhigon
 *
 */
public class RemoveResourceController implements ActionListener, TreeSelectionListener {
	public final String REMOVE_EVENT="remove";	
	private HashSet resourcesToDel = new HashSet();
	
	/**
	 * Constructor
	 * @param view Wizard panel which has the button for delete resources
	 * @param model Publication for delete the resource
	 */
	public RemoveResourceController(JButton button, JTree tree) {				
		//set listeners
		button.addActionListener(this);
		button.setActionCommand(REMOVE_EVENT);
		tree.addTreeSelectionListener(this);
	}
	/*
	 * (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().equals(REMOVE_EVENT)){	
			Object[] o = resourcesToDel.toArray();
			for (int i = 0; i < o.length; i++){
				RemoteResource r = (RemoteResource)o[i];
				r.remove();
			}
		}
		
	}
	/*
	 * (non-Javadoc)
	 * @see javax.swing.event.TreeSelectionListener#valueChanged(javax.swing.event.TreeSelectionEvent)
	 */
	public void valueChanged(TreeSelectionEvent e) {				
		TreePath[] paths = e.getPaths();
		for (int i = 0; i < paths.length; i++){				
				if (e.isAddedPath(paths[i])){
					resourcesToDel.add(paths[i].getLastPathComponent());
				}else{
					resourcesToDel.remove(paths[i].getLastPathComponent());
				}									
		}
	}

}
