/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.gui.selectServer;


import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.EventListener;
import java.util.Iterator;

import javax.swing.JPanel;

import org.gvsig.gui.beans.swing.JButton;
import org.gvsig.publish.PublishRegister;

import com.iver.andami.PluginServices;
import com.iver.andami.persistence.serverData.ServerDataPersistence;
import com.iver.utiles.swing.jcomboServer.JComboServer;
import com.iver.utiles.swing.jcomboServer.ServerData;

/**
 * GUI for server and service selection
 * 
 * @author jvhigon
 *
 */

public class SelectServerPanel extends JPanel {

	/**
	 * Constructor
	 */
	public SelectServerPanel(){
		super();
		initComponents();
		initCombos();
		initLabels();
	}
	private void initLabels(){
		acceptButton.setText(PluginServices.getText(this,"publish_accept"));
		cancelButton.setText(PluginServices.getText(this,"publish_cancel"));
		selectionPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(PluginServices.getText(this,"publish_select_server")));
		labelservice.setText(PluginServices.getText(this,"publish_service"));
		labelurl.setText(PluginServices.getText(this, "publish_url"));
		labelserver.setText(PluginServices.getText(this, "publish_server"));
	}
	private void initComponents() {
		java.awt.GridBagConstraints gridBagConstraints;

		buttonsPanel = new javax.swing.JPanel();
		acceptButton = new JButton();
		cancelButton = new JButton();
		selectionPanel = new javax.swing.JPanel();
		labelservice = new javax.swing.JLabel();
		labelserver = new javax.swing.JLabel();
		servercombo = new javax.swing.JComboBox();
		labelurl = new javax.swing.JLabel();
		servicecombo = new javax.swing.JComboBox();
		serverurlcombo = new JComboServer();

		setLayout(new java.awt.BorderLayout());

		buttonsPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

		
		buttonsPanel.add(acceptButton);

	
		buttonsPanel.add(cancelButton);

		add(buttonsPanel, java.awt.BorderLayout.SOUTH);

		selectionPanel.setLayout(new java.awt.GridBagLayout());

		

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 2;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
		selectionPanel.add(labelservice, gridBagConstraints);

	
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		gridBagConstraints.insets = new java.awt.Insets(2, 5, 5, 2);
		selectionPanel.add(labelserver, gridBagConstraints);

		servercombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 0.5;
		gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
		selectionPanel.add(servercombo, gridBagConstraints);


		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		gridBagConstraints.insets = new java.awt.Insets(5, 5, 2, 2);
		selectionPanel.add(labelurl, gridBagConstraints);

		servicecombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 3;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 0.5;
		gridBagConstraints.insets = new java.awt.Insets(2, 2, 5, 5);
		selectionPanel.add(servicecombo, gridBagConstraints);

		serverurlcombo.setEditable(true);
		serverurlcombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.gridwidth = 3;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new java.awt.Insets(5, 2, 2, 5);
		selectionPanel.add(serverurlcombo, gridBagConstraints);

		add(selectionPanel, java.awt.BorderLayout.CENTER);

	}// </editor-fold>                        


	// Variables declaration - do not modify                     
	private JButton acceptButton;
	private javax.swing.JPanel buttonsPanel;
	private JButton cancelButton;
	private javax.swing.JLabel labelserver;
	private javax.swing.JLabel labelservice;
	private javax.swing.JLabel labelurl;
	private javax.swing.JPanel selectionPanel;
	private javax.swing.JComboBox servercombo;
	private JComboServer serverurlcombo;
	private javax.swing.JComboBox servicecombo;
	// End of variables declaration                   

	/**
	 * sets the listener for all the actions in the panel
	 */
	public void setListener(EventListener listener) {
		//set listener into the buttons
		acceptButton.addActionListener((ActionListener)listener);
		acceptButton.setActionCommand(SelectServerController.NEWSERVER_EVENT_ACCEPT);
		cancelButton.addActionListener((ActionListener)listener);		
		cancelButton.setActionCommand(SelectServerController.NEWSERVER_EVENT_CANCEL);
		serverurlcombo.addActionListener((ActionListener)listener);
		serverurlcombo.setActionCommand(SelectServerController.COMBOSERVERURL_EVENT_CHANGE);
		servercombo.addActionListener((ActionListener)listener);
		servercombo.setActionCommand(SelectServerController.COMBOSERVER_EVENT_CHANGE);
	}
	/**
	 * initialize combos
	 */
	public void initCombos(){
		//remove items
		servercombo.removeAllItems();
		servicecombo.removeAllItems();
		serverurlcombo.removeAllItems();

		//initialize servercombo		
		initServerCombo();

		ArrayList set = PublishRegister.register().getServerNames();
		Iterator i = set.iterator();
		while (i.hasNext()){
			servercombo.addItem(i.next());
		}
		//initialice servicecombo
		set = PublishRegister.register().getServicesNames(servercombo.getSelectedItem().toString());
		i = set.iterator();
		while (i.hasNext()){
			servicecombo.addItem(i.next());
		}
	}
	
	/**
	 * Initializes the serverComboURL with the saved servers 
	 */
	private void initServerCombo(){
		ServerDataPersistence persistence = new ServerDataPersistence(this,"publish_server_data");
		ServerData[] servers = persistence.getArrayOfServerData();

		for (int i=0 ; i<servers.length ; i++){
			persistence.addServerData(servers[i]);
		}
		persistence.setPersistent();
		serverurlcombo.setServerList(servers);
	}
	
	/**
	 * Saves the current selected server in the Andami
	 * persistence system
	 */
	protected void saveCurrentServer() {
		String host = null;
		Object obj = serverurlcombo.getSelectedItem();
		if (obj instanceof ServerData){
			host = ((ServerData)obj).getServerAddress();
		}else{
			host = ((String)obj).trim();
		}
		String server = ((String)servercombo.getSelectedItem());
		String service = ((String)servicecombo.getSelectedItem());
		
		ServerDataPersistence persistence = new ServerDataPersistence(this,"publish_server_data");
		persistence.addServerData(new ServerData(host, server, service));
	}
	
	/**
	 * Updates the server and the service combo with the
	 * selected server url
	 */
	protected void updateCombos(){
		ServerData server = serverurlcombo.getSelectedServer();
		//Sets the server
		for (int i=0 ; i<servercombo.getItemCount() ; i++){
			if (server.getServiceType().compareTo(((String)servercombo.getSelectedItem()).toUpperCase()) == 0){
				servercombo.setSelectedIndex(i);
				break;
			}
		}		
		//Sets the service
		for (int i=0 ; i<servicecombo.getItemCount() ; i++){
			if (server.getServiceSubType().compareTo(((String)servicecombo.getSelectedItem()).toUpperCase()) == 0){
				servicecombo.setSelectedIndex(i);
				break;
			}
		}	
	}
	/**
	 * Updates the service combo when you select a server
	 */
	public void updateServiceCombo() {
		servicecombo.removeAllItems();
		ArrayList set = PublishRegister.register().getServicesNames(servercombo.getSelectedItem().toString());
		Iterator i = set.iterator();
		while (i.hasNext()){
			servicecombo.addItem(i.next());
		}		
	}
	

	public String getSelectedServer(){
		return servercombo.getSelectedItem().toString();
	}
	public String getSelectedService(){
		return servicecombo.getSelectedItem().toString();
	}
	public String getSelectedURL(){		
		return serverurlcombo.getSelectedItem().toString();
	}
}
