/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */

package org.gvsig.publish.infoproject;


/**
 * This interface has the operations for query information about a project
 *  
 * @author Jos Vicente Hign (josevicente.higon@iver.es)
 *
 */
public interface IProjectInfo extends Cloneable {
	
	/**
	 * 
	 * @return String with the name of the project
	 */
	abstract String getName();
	/**
	 * 
	 * @return String with the owner of the project
	 */
	abstract String getOwner();
	
	 /**
	  * 
	  * @return Array of view information
	  */	 
	abstract IViewInfo[] getViewsInfo();
	/**
	 * Search a layerinfo object with the unique identifier defined by the param layerName 
	 * @param layerName
	 * @return an object ILayerInfo which unique identifier is "layerName" or null if the layer doesn't exists
	 */
	abstract ILayerInfo findLayer(String layerName);
	/**
	 * Filters the content of the project information 
	 * 
	 * @param filter
	 */
	abstract void setFilter(FilterProjectInfo filter);
	/**
	 * 
	 * @return project information filter. Null if there isn't a filter defined
	 */
	abstract FilterProjectInfo getFilterProjectInfo();
	/**
	 * Clones this interfaces
	 * 
	 * @return
	 */
	abstract Object clone();
}
