/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.infoproject;

import org.gvsig.publish.infoproject.symbols.ITextSymbolInfo;
import org.gvsig.publish.infoproject.symbols.SymbolInfoFactory;

import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;

public class LabelingInfo implements ILabelingInfo {
	private VectorialLegend legend = null;
	private FLyrVect layer = null;
	/**
	 * Constructor
	 * @param lyr
	 */
	public LabelingInfo(FLyrVect lyr) {
		layer = lyr;
		Legend leg = lyr.getLegend();
		if (leg instanceof VectorialLegend) {
			legend = (VectorialLegend)leg; 
		}
	}
	/**
	 * 
	 * @see org.gvsig.publish.infoproject.ILabelingInfo#getLabelField()
	 */
	public String getLabelField() {				
		return legend.getLabelField();
	}
	/**
	 * 
	 * @see org.gvsig.publish.infoproject.ILabelingInfo#getLabelHeightField()
	 */
	public String getLabelHeightField() {
		return legend.getLabelHeightField();
	}
	/**
	 * 
	 * @see org.gvsig.publish.infoproject.ILabelingInfo#getLabelRotationField()
	 */
	public String getLabelRotationField() {
		return legend.getLabelRotationField();
	}
	/**
	 * 
	 * @see org.gvsig.publish.infoproject.ILabelingInfo#getSymbolInfo()
	 */
	public ITextSymbolInfo getSymbolInfo() {
		return (ITextSymbolInfo) SymbolInfoFactory.getInstance(legend.getDefaultSymbol());
	}
	/**
	 * 
	 * @see org.gvsig.publish.infoproject.ILabelingInfo#isVisibleFeatures()
	 */
	public boolean isVisibleFeatures() {	
		return legend.getDefaultSymbol().isShapeVisible();
	}
	

}
