/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.infoproject.legends;

import org.gvsig.publish.infoproject.ISymbolInfo;
import org.gvsig.publish.infoproject.symbols.SymbolInfoFactory;

import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.SingleSymbolLegend;

public class SingleSymbolLegendInfo implements ISingleSymbolLegendInfo{
	private Legend legend = null;
	private FLyrVect layer = null;
	/**
	 * default constructor
	 * @param legend
	 * @deprecated
	 */
	public SingleSymbolLegendInfo(SingleSymbolLegend legend) {
		this.legend = legend;
	}
	/**
	 * Constructor from FLayer. I need the layer's name in order to build the SLD
	 */
	public SingleSymbolLegendInfo(FLyrVect lyrVect) {
		this.layer = lyrVect;
		this.legend = (SingleSymbolLegend)lyrVect.getLegend();
	}
	public ISymbolInfo getSymbolInfo() {
		return SymbolInfoFactory.getInstance(this.legend.getDefaultSymbol());
	}

	public String getSLDString() {
		if (layer != null){
			return legend.getSLDString(layer.getName());
		}else{
			return legend.getSLDString("default");
		}
				
	}

}
