/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004-2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibaez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.publish.infoproject.legends;


import java.util.HashMap;

import org.gvsig.publish.infoproject.ISymbolInfo;
import org.gvsig.publish.infoproject.symbols.SymbolInfoFactory;

import com.hardcode.gdbms.engine.values.Value;
import com.iver.cit.gvsig.fmap.core.ISymbol;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.rendering.UniqueValueLegend;

public class UniqueValuesLegendInfo implements IUniqueValuesLegendInfo {
	
	private UniqueValueLegend legend=null;
	private FLyrVect layer=null;
	private HashMap symbols = null;
	/**
	 * default constructor
	 * @param legend2
	 * @deprecated
	 */
	public UniqueValuesLegendInfo(UniqueValueLegend legend2) {
		legend = legend2;
		symbols = new HashMap();
		initialize();
	}
	/**
	 * 
	 * @param lyrVect gvSIG vectorial layer
	 */
	public UniqueValuesLegendInfo(FLyrVect lyrVect) {
		this.layer = lyrVect;
		this.legend = (UniqueValueLegend)lyrVect.getLegend();
		this.symbols = new HashMap();
		initialize();
	}
	private void initialize(){
		Object[] values = legend.getValues();
		for (int i = 0; i < values.length; i++){
			symbols.put(values[i].toString(), legend.getSymbolByValue((Value)values[i]));			
		}

		
//		ISymbol[] s = legend.getSymbols();
//		//TODO: I don't need the default symbol, then I start by the second element
//		for (int i = 0; i < s.length; i++){
//			symbols.put(s[i].getDescription(), s[i]);
//		}
	}

	public String getFilterItem() {		
		return legend.getFieldName();
	}

	public ISymbolInfo getSymbol(String value) {
		ISymbolInfo isymbol = SymbolInfoFactory.getInstance((ISymbol)symbols.get(value));
		return isymbol;
	}
	

	public String[] getUniqueValues() {		
		Object[] values = legend.getValues();
		String[] stringValues = new String[values.length];
		for (int i = 0; i < values.length; i++){
			stringValues[i] = values[i].toString();
		}
		return stringValues;

		//return legend.getDescriptions();
	}
	/*
	 * (non-Javadoc)
	 * @see org.gvsig.publish.infoproject.ILegendInfo#getSLDString()
	 */
	public String getSLDString() {
		if (layer != null){
			return legend.getSLDString(layer.getName());
		}else{
			return legend.getSLDString("default");
		}			
	}

}
